NDB_BLOB_TOOL(1)

NAME
ndb_blob_tool - check and repair BLOB and TEXT columns of NDB Cluster tables

SYNOPSIS

ndb_blob_tool options table [column, ...]

DESCRIPTION

This tool can be used to check for and remove orphaned BLOB column parts from NDB tables, as well as to generate a file listing any orphaned parts. It is sometimes useful in diagnosing and repairing corrupted or damaged NDB tables containing BLOB or TEXT columns.

The basic syntax for ndb_blob_tool is shown here:

    ndb_blob_tool [options] table [column, ...]

Unless you use the --help option, you must specify an action to be performed by including one or more of the options --check-orphans, --delete-orphans, or --dump-file. These options cause ndb_blob_tool to check for orphaned BLOB parts, remove any orphaned BLOB parts, and generate a dump file listing orphaned BLOB parts, respectively, and are described in more detail later in this section.

You must also specify the name of a table when invoking ndb_blob_tool. In addition, you can optionally follow the table name with the (comma-separated) names of one or more BLOB or TEXT columns from that table. If no columns are listed, the tool works on all of the table's BLOB and TEXT columns. If you need to specify a database, use the --database (-d) option.

The --verbose option provides additional information in the output about the tool's progress.

The following table includes options that are specific to ndb_blob_tool. Additional descriptions follow the table. For options common to most NDB Cluster programs (including ndb_blob_tool), see Options Common to NDB Cluster Programs(1).

Table 21.333. Command-line options for the ndb_blob_tool program
Format | Description | Added, Deprecated, or Removed
--check-orphans | Check for orphan blob parts | All MySQL 5.7 based releases
--database=db_name, -d | Database to find the table in. | All MySQL 5.7 based releases
--delete-orphans | Delete orphan blob parts | All MySQL 5.7 based releases
--dump-file=file | Write orphan keys to specified file | All MySQL 5.7 based releases
--verbose, -v | Verbose output | All MySQL 5.7 based releases

    • --check-orphans
    Property | Value
    Command-Line Format | --check-orphans
    Type | Boolean
    Default Value | FALSE

    Check for orphaned BLOB parts in NDB Cluster tables.

    • --database=db_name, -d
    Property | Value
    Command-Line Format | --database=db_name
    Type | String
    Default Value | [none]

    Specify the database to find the table in.

    • --delete-orphans
    Property | Value
    Command-Line Format | --delete-orphans
    Type | Boolean
    Default Value | FALSE

    Remove orphaned BLOB parts from NDB Cluster tables.

    • --dump-file=file
    Property | Value
    Command-Line Format | --dump-file=file
    Type | File name
    Default Value | [none]

    Writes a list of orphaned BLOB column parts to file. The information written to the file includes the table key and BLOB part number for each orphaned BLOB part.

    • --verbose
    Property | Value
    Command-Line Format | --verbose
    Type | Boolean
    Default Value | FALSE

    Provide extra information in the tool's output regarding its progress.
Example.PP First we create an NDB table in the test database, using the CREATE TABLE statement shown here:

    USE test;
    CREATE TABLE btest (
        c0 BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
        c1 TEXT,
        c2 BLOB
    )   ENGINE=NDB;

Then we insert a few rows into this table, using a series of statements similar to this one:

    INSERT INTO btest VALUES (NULL, 'x', REPEAT('x', 1000));

When run with --check-orphans against this table, ndb_blob_tool generates the following output:

    shell> ndb_blob_tool --check-orphans --verbose -d test btest
    connected
    processing 2 blobs
    processing blob #0 c1 NDB$BLOB_19_1
    NDB$BLOB_19_1: nextResult: res=1
    total parts: 0
    orphan parts: 0
    processing blob #1 c2 NDB$BLOB_19_2
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=0
    NDB$BLOB_19_2: nextResult: res=1
    total parts: 10
    orphan parts: 0
    disconnected
    NDBT_ProgramExit: 0 - OK

The tool reports that there are no NDB BLOB column parts associated with column c1, even though c1 is a TEXT column. This is due to the fact that, in an NDB table, only the first 256 bytes of a BLOB or TEXT column value are stored inline, and only the excess, if any, is stored separately; thus, if there are no values using more than 256 bytes in a given column of one of these types, no BLOB column parts are created by NDB for this column. See Section 11.8, “Data Type Storage Requirements”, for more information.

COPYRIGHT

Copyright © 1997, 2018, Oracle and/or its affiliates. All rights reserved.

This documentation is free software; you can redistribute it and/or modify it only under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.

This documentation is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA or see http://www.gnu.org/licenses/.

SEE ALSO
For more information, please refer to the MySQL Reference Manual, which may already be installed locally and which is also available online at http://dev.mysql.com/doc/.

AUTHOR
Oracle Corporation (http://dev.mysql.com/).